#include <cstdio>
#include <cstring>
#include <vector>
using namespace std;

const int mod = 1000000007;

int n, m;
vector<int> g[1 << 17];
int mem[128][6020];

int x, y, l;

int go(int v, int d) {
  if (mem[v][d] != -1) {
    return mem[v][d];
  }
  if (d == 0) {
    return v == y;
  }
  int sol = 0;
  for (int i = 0; i < (int) g[v].size(); ++i) {
    sol += go(g[v][i], d - 1);
    if (sol >= mod) {
      sol -= mod;
    }
  }
  return (mem[v][d] = sol);
}

int main() {
  scanf("%d %d", &n, &m);
  for (int i = 0; i < m; ++i) {
    int j, k;
    scanf("%d %d", &j, &k);
    g[j].push_back(k);
    g[k].push_back(j);
  }
  scanf("%d %d %d", &x, &y, &l);

  memset(mem, -1, sizeof(mem));

  printf("%d\n", go(x, l));
  return 0;
}
